// Prce se zlomky - pipomnky a nmty na adresu:
// Fr. Sokolovsk
// E-MAIL: sokolovs@pascal.fjfi.cvut.cz
// WWW strnka: http://pascal.fjfi.cvut.cz/~sokolovs

#pragma hdrfile="TCDEF.SYM" // pro urychlen pekladu
#include <iostream.h>
#include <process.h>
#include <math.h> //pouvm funkci sqrt
#include "zlomky.h"
#ifndef __zlomky_cpp
#define __zlomky_cpp

int SpolecnyJmenovatel(int c1,int c2) {
 if (c1*c2==0) {cout << "V jednom ze zlomk je nula." << endl;exit;}
 if (c1%c2==0) return c1; //c1 je nsobek c2 a je tedy vt
 if (c2%c1==0) return c2; //c2 je nsobek c1 a je tedy vt
 return c1*c2;
}

void zlomky::Test()
{
 int p=sqrt(min(citatel,jmenovatel))+1;
 if (jmenovatel==0) {cout << "Zlomek obsahuje nulu ve jmenovateli." << endl;exit(1);}
 if (citatel%jmenovatel==0) {citatel=citatel/jmenovatel;jmenovatel=1;} //itatel je nsobkem jmenovatele, itatel je tedy vt
 if (jmenovatel%citatel==0) {jmenovatel=jmenovatel/citatel;citatel=1;} //jmenovatel je nsobkem itatele, jmenovatel je tedy vt
 // krcen zlomku
 for(int i=2;i<=p;i++) {
  if ((citatel%i==0) && (jmenovatel%i==0)) {citatel=citatel/i;jmenovatel=jmenovatel/i;}
 }
}

zlomky zlomky::operator +(zlomky z)
{
 int spol;
 zlomky pom;
 Test();z.Test();
 spol=SpolecnyJmenovatel(jmenovatel,z.jmenovatel);
 pom.jmenovatel=spol;
 pom.citatel=spol/jmenovatel*citatel+spol/z.jmenovatel*z.citatel;
 return pom;
}

zlomky zlomky::operator -(zlomky z)
{
 int spol;
 zlomky pom;
 Test();z.Test();
 spol=SpolecnyJmenovatel(jmenovatel,z.jmenovatel);
 pom.jmenovatel=spol;
 pom.citatel=spol/jmenovatel*citatel-spol/z.jmenovatel*z.citatel;
 return pom;
}

zlomky zlomky::operator *(zlomky z)
{
 zlomky pom;Test();z.Test();
 pom.citatel=citatel*z.citatel;
 pom.jmenovatel=jmenovatel*z.jmenovatel;
 return pom;
}

zlomky zlomky::operator /(zlomky z)
{
 zlomky pom;Test();z.Test();
 pom.citatel=citatel*z.jmenovatel;
 pom.jmenovatel=jmenovatel*z.citatel;
 return pom;
}

ostream& operator << (ostream& proud, zlomky z)
{
 proud << z.citatel << '/' << z.jmenovatel;
 return proud;
}

istream& operator >> (istream& proud, zlomky& z) //nutn pedat referenci, protoe promnn z je zde jako vstup
{
 cout << "Zadejte itatel: ";
 proud >> z.citatel;
 do {
  cout << "Zadejte jmenovatel: ";
  proud >> z.jmenovatel;
 } while (z.jmenovatel==0);
 return proud;
}
#endif
